<?php
/*
 $Id: usercal-new.php,v 1.2 2003/07/25 00:00:35 adeniz Exp $

 Copyright (C) 2003 Baker Research, Ltd.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*
  This script creates a new record in the termine table in the
  PHProjekt database for a given user.

  See protocols.dvi for a description of this script.

*/

// Include the common library.
require('sync_common.php');

// If debugging is enabled, put up a web page with the variable info.
if (isset($debugVars)) {
  echo debug_header("$PHP_SELF");
  debug($userName, "userName");
  debug($userPW, "userPW");
  debug($recDesc, "recDesc");
  debug($recNote, "recNote");
  debug($recDate, "recDate");
  debug($recBegin, "recBegin");
  debug($recEnd, "recEnd");
  debug($ldap, "ldap");
  debug($pw_crypt, "pw_crypt");
}

// Check that all required variables are present.
if (!isset($userName) || (!isset($userPW)) || (!isset($recDate)) ||
    (!isset($recBegin)) || (!isset($recEnd)) ||
    (!isset($recNote) && !isset($recDesc)) ) {
  error_exit("$programError:  Missing input", $debugVars);
}

// Set non-existant variables to be NULL.
if (!isset($recNote)) {
  $dbNote = "null";
}
else {
  $dbNote = "'$recNote'";
}
if (!isset($recDesc)) {
  $dbDesc = "null";
}
else {
  $dbDesc = "'$recDesc'";
}

// Check the format of the date.
$recDates = check_date_format_exit($recDate, $debugVars);

// Check the format of the times.
$recBegins = check_time_format_exit($recBegin, $debugVars);
$recEnds = check_time_format_exit($recEnd, $debugVars);

// Check the order of the times.
$timeStart = $recBegins[0] * 60 + $recBegins[1];
$timeEnd = $recEnds[0] * 60 + $recEnds[1];
if ($timeStart > $timeEnd) {
  error_exit("$dataError:  Start time '$recBegin' is later than end time ".
	     "'$recEnd'", $debugVars);
}

// Get the PHProjekt user ID, checking for unique userName and correct userPW.
$dbID = check_user_pw($userName, $userPW, $debugVars);

// Format the date and time for SQL.
$dbDate = db_format_date($recDates);
$dbBegin = db_format_time($recBegins);
$dbEnd = db_format_time($recEnds);

// Assemble the SQL query to create a record.
$query = "INSERT INTO termine
  VALUES($dbIDnull,'$dbID','$dbID',$dbDesc,$dbNote,
    null,'$dbTSnull',
    '$dbDate','$dbBegin','$dbEnd',null,null,null,null,
    null, null, null,'$defaultVisibility', null, null)";
if (isset($debugVars))
  debug($query, "Record creation");

// Execute the query.
$result = db_query($query) or error_exit("$databaseError:  Query:  '$query'",
					 $debugVars);

// Obtain the record ID of the record just created.
// First create the query to read the ID.
if (!isset($recNote)) {
  $noteQuery = "note IS null";
}
else {
  $noteQuery = "note='$recNote'";
}
if (!isset($recDesc)) {
  $descQuery = "event is null";
}
else {
  $descQuery = "event='$recDesc'";
}
$query = "select ID from termine where $descQuery and $noteQuery and
    an='$dbID' and datum='$dbDate' and anfang='$dbBegin' and ende='$dbEnd'
    and erstellt = '$dbTSnull'";
if (isset($debugVars))
  debug($query, "Record ID");
$result = db_query($query) or error_exit("$databaseError:  Query:  '$query'",
					 $debugVars);
$row = db_fetch_row($result);
$recID = $row[0];

// Send the ID of this record.
echo "$success:  $recID";

// If debugging is enabled, show the ID and send the footer.
if (isset($debugVars)) {
  debug($recID, "New record ID");
  echo debug_footer();
}
?>
